package cn.iocoder.yudao.module.system.service.extra;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.controller.admin.extra.vo.RiskDisclosurePageReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.extra.ElderlyExtraRiskDisclosureDO;
import cn.iocoder.yudao.module.system.dal.mysql.extra.ElderlyExtraRiskDisclosureMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.system.enums.ErrorCodeConstants.ELDERLY_EXTRA_RISK_DISCLOSURE_NOT_EXISTS;

/**
 * （附件）风险知情书 Service 实现
 *
 * @author 管理员
 */
@Service
@Slf4j
public class ElderlyExtraRiskDisclosureServiceImpl implements ElderlyExtraRiskDisclosureService {

    @Resource
    private ElderlyExtraRiskDisclosureMapper mapper;

    @Override
    public Long create(ElderlyExtraRiskDisclosureDO createReqVO) {
        mapper.insert(createReqVO);
        return createReqVO.getId();
    }

    @Override
    public void update(ElderlyExtraRiskDisclosureDO updateReqVO) {
        validateExists(updateReqVO.getId());
        mapper.updateById(updateReqVO);
    }

    @Override
    public void delete(Long id) {
        validateExists(id);
        mapper.deleteById(id);
    }

    @Override
    public PageResult<ElderlyExtraRiskDisclosureDO> findPage(RiskDisclosurePageReqVO reqVO) {
        return mapper.selectPage(reqVO);
    }

    @Override
    public ElderlyExtraRiskDisclosureDO getDetail(Long id) {
        return validateExists(id);
    }

    @Override
    public List<ElderlyExtraRiskDisclosureDO> getListByElderId(Long elderId) {
        return mapper.selectList(
                new LambdaQueryWrapperX<ElderlyExtraRiskDisclosureDO>()
                        .eqIfPresent(ElderlyExtraRiskDisclosureDO::getElderId, elderId)
                        .orderByDesc(ElderlyExtraRiskDisclosureDO::getCreateTime)
        );
    }

    private ElderlyExtraRiskDisclosureDO validateExists(Long id) {
        ElderlyExtraRiskDisclosureDO record = mapper.selectById(id);
        if (record == null) {
            throw exception(ELDERLY_EXTRA_RISK_DISCLOSURE_NOT_EXISTS);
        }
        return record;
    }

}
